## net.i2p.router.tunnel
Class PumpedTunnelGateway

    java.lang.Object
      net.i2p.router.tunnel.TunnelGateway
          net.i2p.router.tunnel.PumpedTunnelGateway

    public class PumpedTunnelGateway

extends TunnelGateway

Serve as the gatekeeper for a tunnel, accepting messages, coallescing and/or fragmenting them before wrapping them up for tunnel delivery. The flow here is:

1. add an I2NPMessage (and a target tunnel/router, if necessary)
2. that message is queued up into a TunnelGateway.Pending and offered to the assigned QueuePreprocessor.
3. that QueuePreprocessor may then take off any of the TunnelGateway.Pending messages or instruct the TunnelGateway to offer it the messages again in a short while (in an attempt to coallesce them).
4. when the QueueProcessor accepts a TunnelGateway.Pending, it preprocesses it into fragments, forwarding each preprocessed fragment group through the Sender.
5. the Sender then encrypts the preprocessed data and delivers it to the Receiver.
6. the Receiver now has the encrypted message and may do with it as it pleases (e.g. wrap it as necessary and enqueue it onto the OutNetMessagePool, or if debugging, verify that it can be decrypted properly)

Nested Class Summary

Nested classes/interfaces inherited from class net.i2p.router.tunnel.TunnelGateway
`TunnelGateway.Pending, TunnelGateway.PendingImpl, TunnelGateway.QueuePreprocessor, TunnelGateway.Receiver, TunnelGateway.Sender`

Field Summary

Fields inherited from class net.i2p.router.tunnel.TunnelGateway
`_context, _delayedFlush, _flushFrequency, _lastFlush, _log, _messagesSent, _preprocessor, _queue, _receiver, _sender`

Constructor Summary
`PumpedTunnelGateway(I2PAppContext context, TunnelGateway.QueuePreprocessor preprocessor, TunnelGateway.Sender sender, TunnelGateway.Receiver receiver, TunnelGatewayPumper pumper)`

Method Summary
`void` `add(I2NPMessage msg, Hash toRouter, TunnelId toTunnel)` Add a message to be sent down the tunnel, either sending it now (perhaps coallesced with other pending messages) or after a brief pause (_flushFrequency).
`(package private) void` `pump(java.util.List queueBuf)` run in one of the TunnelGatewayPumper's threads, this pulls pending messages off the prequeue, adds them to the queue and then tries to preprocess the queue, scheduling a later delayed flush as necessary.

Methods inherited from class net.i2p.router.tunnel.TunnelGateway
`add, getMessagesSent`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PumpedTunnelGateway

    public PumpedTunnelGateway(I2PAppContext context,
                               TunnelGateway.QueuePreprocessor preprocessor,
                               TunnelGateway.Sender sender,
                               TunnelGateway.Receiver receiver,
                               TunnelGatewayPumper pumper)

Parameters:
  `preprocessor` - this pulls Pending messages off a list, builds some full preprocessed messages, and pumps those into the sender
  `sender` - this takes a preprocessed message, encrypts it, and sends it to the receiver
  `receiver` - this receives the encrypted message and forwards it off to the first hop

Method Detail

### add

    public void add(I2NPMessage msg,
                    Hash toRouter,
                    TunnelId toTunnel)

  Add a message to be sent down the tunnel, either sending it now (perhaps coallesced with other pending messages) or after a brief pause (_flushFrequency). If it is queued up past its expiration, it is silently dropped

  Overrides:
    `add` in class `TunnelGateway`
  Parameters:
    `msg` - message to be sent through the tunnel
    `toRouter` - router to send to after the endpoint (or null for endpoint processing)
    `toTunnel` - tunnel to send to after the endpoint (or null for endpoint or router processing)

### pump

    void pump(java.util.List queueBuf)

  run in one of the TunnelGatewayPumper's threads, this pulls pending messages off the prequeue, adds them to the queue and then tries to preprocess the queue, scheduling a later delayed flush as necessary. this allows the gw.add call to go quickly, rather than blocking its callers on potentially substantial processing.